<?php

// assert framework initialization
defined('CON_FRAMEWORK') || die('Illegal call: Missing framework initialization - request aborted.');

$idart = cRegistry::getArticleId();

// When in backend edit mode add a label so the author
// knows what to type in the shown field.
if (cRegistry::isBackendEditMode()) {
    $label = mi18n("RSS-Reader");
} else {
    $label = NULL;
};


if ("CMS_VALUE[2]" == "") { $anzahl = 20; } else { $anzahl = "CMS_VALUE[2]"; };
if ("CMS_VALUE[3]" == "") { $contentLength = 150; } else { $contentLength = "CMS_VALUE[3]"; };

if ("CMS_VALUE[1]" == "")
{
  $rssFeed = "";
} else {
  $rssFeed = getContent($cfgClient[$client]['cache']['path'].str_replace('/', '_', str_replace('http://', '', "CMS_VALUE[1]")).'_'.$idart.'.txt', "CMS_VALUE[1]", $hours = 4, $anzahl, $contentLength);
};

// use template to display navigation
$tpl = cSmartyFrontend::getInstance();
$tpl->assign('label', $label);
$tpl->assign('rss', $rssFeed);
$tpl->assign('more', mi18n("mehr") );
$tpl->display('get.tpl');




/*** Hilfsfunktionen ***/


/* In Anlehnung an: http://davidwalsh.name/php-cache-function */
function getContent($file, $url, $hours = 24, $anzahl=99, $contentLength=150) {
	//vars
	$currentTime = time(); $expireTime = $hours * 60 * 60; if (file_exists($file)) { $fileTime = filemtime($file); };
	//decisions, decisions
	if(file_exists($file) && ($currentTime - $expireTime < $fileTime)) {
		//returning from cached file
		return (array) json_decode(file_get_contents($file), true);
	}
	else {
			$content = readRSSFeed($url, $anzahl, $contentLength);
			//if no connection use cached content
			if (!empty($content)) {
				file_put_contents($file,json_encode($content));
			} 
			else {
				$content = (array) json_decode(file_get_contents($file), true);
			};
			
			return $content;
	};
}



/* http://stackoverflow.com/questions/3346628/retrieving-rss-feed-with-tag-contentencoded */
function readRSSFeed($url, $anzahl, $contentLength=150){
	
	$rss = new DOMDocument();
	$rssData = getURL($url);
	$rss->loadXML($rssData);
	//$rss->load($url);
	$feed = array();
	$i = 0;
	foreach ($rss->getElementsByTagName('item') as $node) {
		
		$item = array (
			'title' => $node->getElementsByTagName('title')->item(0)->nodeValue,
			'link' => $node->getElementsByTagName('link')->item(0)->nodeValue,
			'pubDate' => date("d.m.Y", strtotime( $node->getElementsByTagName('pubDate')->item(0)->nodeValue ) ),
			'description' => $node->getElementsByTagName('description')->item(0)->nodeValue,
			'content' => $node->getElementsByTagName('encoded')->item(0)->nodeValue,
			'content_short' => strip_tags(cApiStrTrimAfterWord( $node->getElementsByTagName('encoded')->item(0)->nodeValue, $contentLength))
		);
		array_push($feed, $item);
		$i = $i+1; if ($i==$anzahl) { return $feed; };
	};
	
	return $feed;
};


/* http://davidwalsh.name/php-cache-function */
/* gets content from a URL via curl */
function getUrl($url) {
	$ch = curl_init();
	curl_setopt($ch,CURLOPT_URL,$url);
	curl_setopt($ch,CURLOPT_RETURNTRANSFER,1); 
	curl_setopt($ch,CURLOPT_CONNECTTIMEOUT,5);
	$content = curl_exec($ch);
	curl_close($ch);
	return $content;
};




?>